# dbkan 11/23
# d001.pyw
# GUIのためのtkinterをインポートする
import tkinter
# PostgreSQLの接続モジュールをインポートする
import psycopg2 #PostgreSQL用

class MainWindow(tkinter.Frame):

    def __init__(self, parent):
        super(MainWindow, self).__init__(parent)
        self.parent = parent
        self.grid(row=0, column=0)
        # Widgets
        self.lblTSNO = tkinter.Label(self, text="NO:", anchor=tkinter.W, width=5)
        self.txtTSNO = tkinter.Entry(self, width=12)
        #self.btnINS = tkinter.Button(self, text='挿入', command=self.btn_Save)
        #self.btnSEL = tkinter.Button(self, text='検索', command=self.btn_Search)
        self.lblNAME = tkinter.Label(self, text="品名:", anchor=tkinter.W, width=5)
        self.txtNAME = tkinter.Entry(self, width=46)
        self.btnSEL = tkinter.Button(self, text='検索', command=self.btn_Search)
        self.btnINS = tkinter.Button(self, text='挿入', command=self.btn_Ins)
        self.lblTSQTY = tkinter.Label(self, text="数量:", anchor=tkinter.W, width=5)
        self.txtTSQTY = tkinter.Entry(self, width=22)
        self.btnUPD = tkinter.Button(self, text='更新', command=self.btn_Save)
        self.btnDEL = tkinter.Button(self, text='削除', command=self.btn_Dele)
        # ステータスラベル
        self.lblStatus = tkinter.Label(self, text='', relief=tkinter.SUNKEN)
        # Layout
        self.lblTSNO.grid(row=0, column=0, padx=2, pady=2, sticky=tkinter.W)
        self.txtTSNO.grid(row=0, column=1, padx=2, pady=2, sticky=tkinter.W)
        #self.btnSEL.grid(row=0, column=2, padx=2, pady=2, sticky=tkinter.E)
        self.lblNAME.grid(row=1, column=0, padx=2, pady=2, sticky=tkinter.W)
        self.txtNAME.grid(row=1, column=1, padx=2, pady=2, sticky=tkinter.W)
        self.lblTSQTY.grid(row=2, column=0, padx=2, pady=2, sticky=tkinter.W)
        self.txtTSQTY.grid(row=2, column=1, padx=2, pady=2, sticky=tkinter.W)
        self.btnSEL.grid(row=0, column=2, padx=2, pady=2, sticky=tkinter.E)
        self.btnUPD.grid(row=2, column=2, padx=2, pady=2, sticky=tkinter.E)
        self.btnINS.grid(row=3, column=2, padx=2, pady=2, sticky=tkinter.E)
        self.btnDEL.grid(row=4, column=2, padx=2, pady=2, sticky=tkinter.E)
        self.lblStatus.grid(row=5, column=1, padx=2, pady=2, sticky=tkinter.W+tkinter.E)
        # initilize
        #self.conn = mysql.connector.connect(user='root', password='password', host='localhost', database='shopdb')
        #if self.conn.is_connected() :
        #    self.lblStatus.configure(text="shopdbを開きました。")
        #else :
        #    self.lblStatus.configure(text="shopdbを開けません。")
        #self.conn = psycopg2.connect(host='192.168.24.112',database='a01',user='postgres',password='Passwd643',port=5432)
        self.conn = psycopg2.connect(host='27.133.155.134',database='a02',user='postgres',password='dbPasswd123',port=5432)

        self.cur = self.conn.cursor()
        self.txtTSNO.focus_set()

    def btn_Search(self, *ignore):
        strTSNO=self.txtTSNO.get()
        sql="SELECT * FROM test_tbl2 WHERE tsno='" + strTSNO + "';"
        self.lblStatus.configure(text="sql="+sql)
        self.cur.execute(sql)
        r = self.cur.fetchone()
        self.txtNAME.delete(0, tkinter.END)
        self.txtTSQTY.delete(0, tkinter.END)
        if r==None:
            self.lblStatus.configure(text=strTSNO+"はありません。")
        else:
            self.txtNAME.insert(0, r[1])
            self.txtTSQTY.insert(0, r[2] )
            self.lblStatus.configure(text="TSNO="+strTSNO)

    def btn_Save(self, *ignore):
        strTSNO=self.txtTSNO.get()
        #strTSNAME=self.txtNAME.get()
        strTSNAME=self.txtNAME.get()
        strTSQTY=self.txtTSQTY.get()
        strValues="Values('" + strTSNO +"','" + strTSNAME + "','" + strTSQTY +"')" 
        #sql="REPLACE INTO test_tbl2(tsno, name, tsqty) " + strValues + ";"
        sql="UPDATE test_tbl2 SET tsno="+ strTSNO+" , "+"tsname='" +strTSNAME+"' , "+"tsqty="+strTSQTY+" Where tsno= "+strTSNO+ " ;"
        self.cur.execute(sql)
        self.conn.commit()
        self.lblStatus.configure(text="保存しました。")

    def btn_Ins(self, *ignore):
        strTSNO=self.txtTSNO.get()
        #strTSNAME=self.txtNAME.get()
        strTSNAME=self.txtNAME.get()
        strTSQTY=self.txtTSQTY.get()
        strValues="Values('" + strTSNO +"','" + strTSNAME + "','" + strTSQTY +"')" 
        #sql="REPLACE INTO test_tbl2(tsno, name, tsqty) " + strValues + ";"
        sql="Insert into test_tbl2 (tsno,tsname,tsqty)"+strValues+ " ;"
        self.cur.execute(sql)
        self.conn.commit()
        self.lblStatus.configure(text="新規に保存しました。")

    def btn_Dele(self, *ignore):
        strTSNO=self.txtTSNO.get()
        #strTSNAME=self.txtNAME.get()
        strTSNAME=self.txtNAME.get()
        strTSQTY=self.txtTSQTY.get()
        strValues="Values('" + strTSNO +"','" + strTSNAME + "','" + strTSQTY +"')" 
        #sql="REPLACE INTO test_tbl2(tsno, name, tsqty) " + strValues + ";"
        sql="DELETE FROM test_tbl2 "+" Where tsno= "+strTSNO+ " ;"
        self.cur.execute(sql)
        self.conn.commit()
        self.lblStatus.configure(text="1件削除しました")

    def quit(self, event=None):
        self.conn.close()
        self.parent.destroy()

application = tkinter.Tk()
application.title('PG_Edit_test_tbl2')
window = MainWindow(application)
application.protocol('WM_DELETE_WINDOW', window.quit)
application.mainloop()


